﻿using MetadataExtractor;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace EXIF
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
            openFileDialog.Filter = "Image Files|*.jpg;*.jpeg;*.png;*.gif;*.tif;...";
        }

        private void btnImageSelection_Click(object sender, EventArgs e)
        {
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(openFileDialog.FileName);
                try
                {
                    Image image = Image.FromStream(streamReader.BaseStream);
                    pbImage.Image = image;
                    #region "MetadataExtractor"

                    IReadOnlyList<MetadataExtractor.Directory> directories = ImageMetadataReader.ReadMetadata(openFileDialog.FileName);

                    StringBuilder stringBuilder = new StringBuilder();
                    foreach (MetadataExtractor.Directory directory in directories)
                        foreach (MetadataExtractor.Tag tag in directory.Tags)
                            stringBuilder.Append($"{directory.Name} - {tag.Name} = {tag.Description}\n");

                    #endregion

                    richTextBox.Text = stringBuilder.ToString();
                }
                catch (Exception ex)
                {
                    MessageBox.Show($"Exception: {ex.Message}");
                }
                finally
                {
                    streamReader.Dispose();
                }
            }
        }
    }
}
